import redis


class RedisBackend(object):

    def __init__(self, xmpp):
        self.xmpp = None
        self.redis = redis.Redis()

    def register(self, xmpp, plugins=None):
        if plugins is None:
            plugins = self.xmpp.plugin
        elif not isinstance(plugins, (list, set, tuple)):
            plugins = [plugins]

        self.xmpp = xmpp
        for name in plugins:
            for op in self.xmpp[name].backend_api:
                self.xmpp[name].api.register('%s_%s' % (name, op),
                        default=True)

    def xep_0012_set_last_activity(self, jid, node, ifrom, data):
        seconds = data.get('seconds', None)
        if seconds is None:
            seconds = 0

        status = data.get('status', None)
        if status is None:
            status = ''

        activity = {
            'seconds': datetime.now() - timedelta(seconds=seconds),
            'status': status
        }

        return self.

    def xep_0012_get_last_activity(self, jid, node, ifrom, data):
        pass

    def xep_0012_del_last_activity(self, jid, node, ifrom, data):
        pass

    def xep_0027_get_keyids(self, jid, node, ifrom, data):
        return self.redis.hkeys('sleekxmpp:xep_0027:keyids:%s' % jid)

    def xep_0027_get_keyid(self, jid, node, ifrom, keyid):
        return self.redis.hget('sleekxmpp:xep_0027:keyids:%s' % jid, keyid)

    def xep_0027_set_keyid(self, jid, node, ifrom, keyid):
        return self.redis.hset('sleekxmpp:xep_0027:keyids:%s' % jid, keyid)

    def xep_0027_del_keyid(self, jid, node, ifrom, data):
        return self.redis.hdel('sleekxmpp:xep_0027:keyids:%s' % jid, keyid)

    def xep_0030_get_info(self, jid, node, ifrom, data):
        pass

    def xep_0030_set_info(self, jid, node, ifrom, data):
        pass

    def xep_0030_set_identities(self, jid, node, ifrom, data):
        pass

    def xep_0030_del_identities(self, jid, node, ifrom, data):
        pass

    def xep_0030_set_features(self, jid, node, ifrom, data):
        pass

    def xep_0030_del_features(self, jid, node, ifrom, data):
        pass

    def xep_0030_get_items(self, jid, node, ifrom, data):
        pass

    def xep_0030_set_items(self, jid, node, ifrom, data):
        pass

    def xep_0030_get_items(self, jid, node, ifrom, data):
        pass

    def xep_0030_add_identity(self, jid, node, ifrom, data):
        pass

    def xep_0030_del_identity(self, jid, node, ifrom, data):
        pass

    def xep_0030_add_feature(self, jid, node, ifrom, data):
        pass

    def xep_0030_del_feature(self, jid, node, ifrom, data):
        pass

    def xep_0030_add_item(self, jid, node, ifrom, data):
        pass

    def xep_0030_del_item(self, jid, node, ifrom, data):
        pass

    def xep_0030_cache_info(self, jid, node, ifrom, data):
        pass

    def xep_0030_get_cached_info(self, jid, node, ifrom, data):
        pass

    def xep_0030_supports(self, jid, node, ifrom, data):
        pass

    def xep_0030_has_identity(self, jid, node, ifrom, data):
        pass

    def xep_0054_get_vcard(self, jid, node, ifrom, data):
        pass

    def xep_0054_set_vcard(self, jid, node, ifrom, data):
        pass

    def xep_0054_del_vcard(self, jid, node, ifrom, data):
        pass

    def xep_0115_cache_caps(self, jid, node, ifrom, data):
        pass

    def xep_0115_get_caps(self, jid, node, ifrom, data):
        pass

    def xep_0115_assign_verstring(self, jid, node, ifrom, data):
        pass

    def xep_0115_get_verstring(self, jid, node, ifrom, data):
        pass

    def xep_0115_supports(self, jid, node, iform, data):
        pass

    def xep_0115_has_identity(self, jid, node, ifrom, data):
        pass

    def xep_0128_get_extended_info(self, jid, node, ifrom, data):
        pass

    def xep_0128_set_extended_info(self, jid, node, ifrom, data):
        pass

    def xep_0128_del_extended_info(self, jid, node, ifrom, data):
        pass

    def xep_0153_set_hash(self, jid, node, ifrom, data):
        pass

    def xep_0153_get_hash(self, jid, node, ifrom, data):
        pass

    def xep_0153_reset_hash(self, jid, node, ifrom, data):
        pass

    def xep_0231_get_bob(self, jid, node, ifrom, data):
        pass

    def xep_0231_set_bob(self, jid, node, ifrom, data):
        pass

    def xep_0231_del_bob(self, jid, node, ifrom, data):
        pass
